org.apache.hadoop.io

## Interface RawComparator<T>

- Type Parameters:
    `T` -
  All Superinterfaces:
    Comparator<T>
  All Known Implementing Classes:
    org.apache.hadoop.io.serializer.DeserializerComparator, JavaSerializationComparator, KeyFieldBasedComparator, KeyFieldBasedComparator, RecordComparator, WritableComparator

      @InterfaceAudience.Public
       @InterfaceStability.Stable
      public interface RawComparator<T>
      extends Comparator<T>

  A `Comparator` that operates directly on byte representations of objects.

  See Also:
    `DeserializerComparator`

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `compare(byte[] b1, int s1, int l1, byte[] b2, int s2, int l2)` Compare two objects in binary.

    - ### Methods inherited from interface java.util.Comparator

      `compare, comparing, comparing, comparingDouble, comparingInt, comparingLong, equals, naturalOrder, nullsFirst, nullsLast, reversed, reverseOrder, thenComparing, thenComparing, thenComparing, thenComparingDouble, thenComparingInt, thenComparingLong`

- - ### Method Detail

    - #### compare

          int compare(byte[] b1,
                      int s1,
                      int l1,
                      byte[] b2,
                      int s2,
                      int l2)

      Compare two objects in binary. b1[s1:l1] is the first object, and b2[s2:l2] is the second object.
      Parameters:
        `b1` - The first byte array.
        `s1` - The position index in b1. The object under comparison's starting index.
        `l1` - The length of the object in b1.
        `b2` - The second byte array.
        `s2` - The position index in b2. The object under comparison's starting index.
        `l2` - The length of the object under comparison in b2.
      Returns:
        An integer result of the comparison.

Copyright © 2022 Apache Software Foundation. All rights reserved.